import { defineComponent as L, ref as r, computed as g, watch as R, onMounted as _, createElementBlock as k, openBlock as w, normalizeStyle as A, Fragment as B, renderList as E, createBlock as M, unref as H, mergeProps as N, withCtx as O, createElementVNode as G, normalizeClass as V } from "vue";
import j from "../spin/index.js";
import { useResizeObserver as q } from "../utils/index.js";
const D = ["href", "target"], J = ["src", "alt", "onLoad"], U = /* @__PURE__ */ L({
  __name: "Waterfall",
  props: {
    images: { default: () => [] },
    columnCount: { default: 3 },
    columnGap: { default: 20 },
    width: { default: "100%" },
    borderRadius: { default: 8 },
    backgroundColor: { default: "#F2F4F8" },
    spinProps: { default: () => ({}) }
  },
  setup($) {
    const a = $, s = r(), m = r(0), C = r(Array(a.images.length).fill(!1)), f = r([]), h = r([]), u = r(Array(a.columnCount).fill(0)), i = r(0), b = g(() => typeof a.width == "number" ? `${a.width}px` : a.width), y = g(() => Math.max(...u.value) + a.columnGap), d = g(() => (m.value - (a.columnCount + 1) * a.columnGap) / a.columnCount), W = g(() => a.images.length);
    R(
      () => [a.images, a.columnCount, a.columnGap, a.width],
      () => {
        m.value = s.value.offsetWidth, u.value = Array(a.columnCount).fill(0), i.value++, p(i.value);
      },
      {
        deep: !0,
        // 强制转成深层侦听器
        flush: "post"
        // 在侦听器回调中访问被 Vue 更新之后的 DOM
      }
    ), _(() => {
      m.value = s.value.offsetWidth, p(i.value);
    }), q(s, () => {
      const e = s.value.offsetWidth;
      a.images.length && e !== m.value && (m.value = e, i.value++, p(i.value));
    });
    async function p(e) {
      h.value = [];
      for (let t = 0; t < W.value; t++)
        if (e === i.value)
          f.value[t] ? v(t) : await z(a.images[t].src, t);
        else
          return !1;
    }
    function z(e, t) {
      if (f.value[t])
        v(t);
      else
        return new Promise((l, n) => {
          const c = new Image();
          c.src = e, c.onload = function() {
            f.value[t] = {
              // 保存已加载图片的尺寸信息
              width: c.width,
              height: c.height
            }, v(t), l("loaded");
          }, c.onerror = function(F) {
            n(new Error(`Failed to load image at ${e}, err: ${F}`));
          };
        });
    }
    function v(e) {
      const t = f.value[e], o = t.height / (t.width / d.value);
      h.value[e] = {
        width: d.value,
        height: o,
        ...I(e, o)
      };
    }
    function I(e, t) {
      if (e < a.columnCount)
        return u.value[e] = a.columnGap + t, {
          top: a.columnGap,
          left: (d.value + a.columnGap) * e + a.columnGap
        };
      {
        const o = Math.min(...u.value);
        let l = 0;
        for (let n = 0; n < a.columnCount; n++)
          if (u.value[n] === o) {
            l = n;
            break;
          }
        return u.value[l] = o + a.columnGap + t, {
          top: o + a.columnGap,
          left: (d.value + a.columnGap) * l + a.columnGap
        };
      }
    }
    function P(e) {
      C.value[e] = !0;
    }
    function S(e) {
      if (e) {
        if (e.name)
          return e.name;
        {
          const t = e.src.split("?")[0].split("/");
          return t[t.length - 1];
        }
      }
      return "";
    }
    return (e, t) => (w(), k("div", {
      ref_key: "waterfallRef",
      ref: s,
      class: "m-waterfall",
      style: A(`
      --waterfall-border-radius: ${e.borderRadius}px;
      --waterfall-bg-color: ${e.backgroundColor};
      --waterfall-width: ${b.value};
      --waterfall-height: ${y.value}px;
    `)
    }, [
      (w(!0), k(B, null, E(h.value, (o, l) => (w(), M(H(j), N({
        class: "waterfall-image",
        style: `width: ${o.width}px; height: ${o.height}px; top: ${o && o.top}px; left: ${o && o.left}px;`,
        spinning: !C.value[l],
        size: "small",
        indicator: "dynamic-circle"
      }, { ref_for: !0 }, e.spinProps, { key: l }), {
        default: O(() => [
          G("a", {
            class: V(["image-link", { "link-cursor": e.images[l].link }]),
            href: e.images[l].link,
            target: e.images[l].target ? e.images[l].target : "_blank"
          }, [
            G("img", {
              class: "image-item",
              src: e.images[l].src,
              alt: S(e.images[l]),
              onLoad: (n) => P(l)
            }, null, 40, J)
          ], 10, D)
        ]),
        _: 2
      }, 1040, ["style", "spinning"]))), 128))
    ], 4));
  }
});
export {
  U as default
};
